# do-re-mi.py
#
# This program generates a sequence of tones using the piezo buzzer connected to IO4.
# The buzzer will play different tones in sequence to demonstrate simple audio output.
# 
# Hardware Requirements:
# - ESP32-C3 Supermini
# - Piezo buzzer connected to IO4
#
# Tested with CircuitPython v9.2.1

import pwmio
import board
import time

pwm = pwmio.PWMOut(board.IO4, duty_cycle=2**15, frequency=440, variable_frequency=True)
for f in (262, 294, 330, 349, 392, 440, 494, 523):
    pwm.frequency = f
    time.sleep(0.5)
