# This program fades an LED connected to IO0 with PWM
# The PWM frequency is set to 1000 Hz.
# The duty cycle is controlled in an infinite loop with 
# linear ramp-up.
#
# Hardware Requirements:
# - ESP32-C3 Supermini
#
# Tested with CircuitPython v9.2.1

import pwmio
import board
import time

#--- Initialize PWM output on IO0 for the LED
led = pwmio.PWMOut(board.IO0, frequency=1000, duty_cycle=0)

while True:
    #--- Fade in --------
    for i in range(128):    
        led.duty_cycle = i<<9
        time.sleep(0.015)   # 15ms delay
    #--- Fade out -------
    for i in range(128):
        led.duty_cycle = (127-i)<<9
        time.sleep(0.015)  # 15ms delay
