# This program fades an LED connected to IO0 with PWM
# The PWM frequency is set to 1000 Hz.
# The duty cycle is controlled in an infinite loop with 
# an exponential-like ramp-up.
#
# Hardware Requirements:
# - ESP32-C3 Supermini
# - LED connected to IO0
#
# Tested with CircuitPython v9.2.1

import pwmio
import board
import time

#--- Initialize PWM output on IO0 for the LED
led = pwmio.PWMOut(board.IO0, frequency=1000, duty_cycle=0)

while True:
    brightness = 0
    increment = 0         # Pre-calculated value
    #--- Fade in --------
    for i in range(128):    
        led.duty_cycle = brightness
        brightness += increment       
        increment += 4    # Gradual increase
        time.sleep(0.015) # 15ms delay
    #--- Fade out -------
    for i in range(128):
        increment -= 4    # Gradual decrease
        brightness -= increment 
        led.duty_cycle = brightness
        time.sleep(0.015)  # 15ms delay
